#ifndef FMQC_INL
#define FMQC_INL

#include <wintypes.h>
#include "mq.h"
#include "feginc.h"
#define COMMIT(trans,a,b,c) Commit(&trans,a,b,c)
#define RELEASE(trans) 
#define MAX_PATH 256
#define FAILED(Status) (((HRESULT)(Status) & 0xC00E0000) == 0xC00E0000)
#define _tprintf printf
#define _T(x) x

#include "mqbench.h"

extern MQPROPVARIANT g_MessagePropVar[];

void Usage_I(void)
{
  static char* pszThreadStr = "[-t count ] ";
  static char* pszNoThreadStr = "";
  g_MultiThreadSupport ? pszThreadStr : pszNoThreadStr;

	printf ("usage: FMQCBench [-s[e|r] count size] [-r count size] [-q queue] [-c]\n");
  printf ("                 [-x[i|s] count] %s[-w] [-p]\n",g_MultiThreadSupport ? pszThreadStr : pszNoThreadStr);
  printf ("                 [-z[s|r] senderQ receiverQ] [-?]\n");

	printf ("-s\tsend 'count' express or recoverable messages. size is in bytes\n");
	printf ("-r\treceive 'count' messages. size is in bytes\n");
	printf ("-x\tuse internal or single transaction\n");
	if( g_MultiThreadSupport ) printf ("-t\tuse threads\n");
	printf ("-q\tqueue path name\n");
	printf ("-c\treceiver clears the queue prior to running\n");
	printf ("-w\twait for first message before measurement\n");
  printf ("-p\tprints test scenario information prior to running test\n");
  printf ("-z\tsyncs the sender and receiver. if (s)ender is used, the\n");
  printf ("  \treceiver starts after sender has finished. if (r)eceiver is used,\n");
  printf ("  \tthe receiver is running before the sender starts running\n");
	printf ("-?\tprint this help\n");
	exit(-1);
}

void TransactionInit(void) {}

void ParsePathParams_I(char* pszPathname, QTYPE qType) {
  switch(qType)
  {
  case APP_Q:
    strncpy(g_Params.I.wcsQueuePathName, pszPathname, MAX_PATH);
    break;
 
  case SENDSYNC_Q:
    strncpy(g_Params.I.wcsSendSyncQueue, pszPathname, MAX_PATH);
    break;

  case RECVSYNC_Q:
    strncpy(g_Params.I.wcsRecvSyncQueue, pszPathname, MAX_PATH);
    break;
  }
}

int IsValidPathname_I(void) {
	return g_Params.I.wcsQueuePathName[0] != '\0';
}

void CleanupTest_I(void) {
  if(g_MessagePropVar[0].MQVAL(caub.pElems)) {
    free(g_MessagePropVar[0].MQVAL(caub.pElems));
    g_MessagePropVar[0].MQVAL(caub.pElems) = NULL;
  }
}

#endif
