#ifndef MSMQ_INL
#define MSMQ_INL

#include <windows.h>
#include <string.h>
#include <tchar.h>
#include <transact.h>
#include <xolehlp.h>
#include <mq.h>
#define COMMIT(trans,a,b,c) trans->Commit(a,b,c)
#define RELEASE(trans) trans->Release()

#include "mqbench.h"

extern MQPROPVARIANT g_MessagePropVar[];

void Usage_I()
{
	printf ("usage: MSMQBench [-s[e|r] count size] [-r count size] [-q queue] [-c]\n"
    			"                 [-x[i|c|s] count] [-t count] [-w] [-p]\n" 
          "                 [-z[s|r] senderQ receiverQ] [-?]\n");

	printf ("-s\tsend 'count' express or recoverable messages. size is in bytes\n");
	printf ("-r\treceive 'count' messages. size is in bytes\n");
	printf ("-x\tuse internal, coordianted or single transaction\n");
	printf ("-t\tuse threads\n");
	printf ("-q\tqueue path name\n");
	printf ("-c\treceiver clears the queue prior to running\n");
	printf ("-w\twait for first message before measurement\n");
  printf ("-p\tprints test scenario information prior to running test\n");
  printf ("-z\tsyncs the sender and receiver. if (s)ender is used, the\n");
  printf ("  \treceiver starts after sender has finished. if (r)eceiver is used,\n");
  printf ("  \tthe receiver is running before the sender starts running\n");
	printf ("-?\tprint this help\n");
	exit(-1);
}

void ParsePathParams_I(char* pszPathname, QTYPE qType) {
  switch(qType)
  {
  case APP_Q:
    mbstowcs(g_Params.I.wcsQueuePathName, pszPathname, MAX_PATH);
    break;
 
  case SENDSYNC_Q:
    mbstowcs(g_Params.I.wcsSendSyncQueue, pszPathname, MAX_PATH);
    break;

  case RECVSYNC_Q:
    mbstowcs(g_Params.I.wcsRecvSyncQueue, pszPathname, MAX_PATH);
    break;
  }
}

int IsValidPathname_I() {
	return g_Params.I.wcsQueuePathName[0] != L'\0';
}

//
// Transaction Dispenser DTC's interface
//
ITransactionDispenser *g_pITxDispenser = NULL;

void TransactionInit()
{
	HRESULT hr;
	hr = DtcGetTransactionManager ( 
			NULL,						//Host Name
			NULL,						//TmName
			IID_ITransactionDispenser,
			0,							//reserved
			0,							//reserved
			0,							//reserved
			(LPVOID *) &g_pITxDispenser
			);

	if (FAILED(hr))
	{
		ErrorExit("DtcGetTransactionManager failed", hr);
	}
}

static
HRESULT
DTCBeginTransaction(
	ITransaction** ppXact
	)
{
	return g_pITxDispenser->BeginTransaction (
								NULL,                       // IUnknown __RPC_FAR *punkOuter,
								ISOLATIONLEVEL_ISOLATED,    // ISOLEVEL isoLevel,
								ISOFLAG_RETAIN_DONTCARE,    // ULONG isoFlags,
								NULL,                       // ITransactionOptions *pOptions
								ppXact
								);
}

void CleanupTest_I()
{
	if(g_pITxDispenser != NULL)
	{
		g_pITxDispenser->Release();
	}
  if(g_MessagePropVar[0].MQVAL(caub.pElems)) {
    free(g_MessagePropVar[0].MQVAL(caub.pElems));
    g_MessagePropVar[0].MQVAL(caub.pElems) = NULL;
  }
}

#endif
